<!-- -*- mode: markdown; mode: flyspell -*- -->
# bash-base Changelog

## [0.4.17] - 2019-09-26
### Changed
* bb_array_copy_without_vals: fixed return code
* bb_array_iter, map, map2, fold_* calls now return callback fails

## [0.4.16] - 2019-09-09
### Changed
* bb_msg_from_stdin got configurable prefix

## [0.4.15] - 2019-09-06
### Added
+ bb_msg_from_stdin

## [0.4.14] - 2019-08-12
### Added
+ bb_lock_aquire
+ bb_lock_release

## [0.4.13] - 2019-07-25
### Changed
* bb_validate_* functions stay quiet if caller-name is empty

## [0.4.12] - 2019-07-24
### Added
+ bb_validate_[u]int
+ bb_validate_regex

## [0.4.11] - 2019-07-17
### Changed
+ use bb_hex_validate in own code
+ API docu cleanup

## [0.4.10] - 2019-07-15
### Added
+ bb_hex_validate

## [0.4.9] - 2019-07-13
### Added
+ bb_array_copy_without_vals
+ bb_array_remove_vals
+ bb_hex_* functions

## [0.4.8] - 2019-06-10
### Added
+ bb_array_map2
+ bb_string_compare
+ bb_array_contains_value
### Changed
* bb_executables_in_path: fix bug with absolute paths
* cleanup example.sh
* code cleanup to satisfy new shellcheck version
* fixed extra args bug in bb_array_filter

## [0.4.7] - 2019-05-11
### Added
+ bb_array_compare
+ bb_array_fold_left and right
+ bb_array_reverse
### Changed
* fix typo in bb_executables_in_path and make it log less
* regress now compares arrays correct
* regress now adds dirt to destination arrays  before using them
* fixed array funs to clean destination before using it
* bb_array_join now works for join strings with more than one char

## [0.4.6] - 2019-05-10
### Changed
* make timestamps more readable

## [0.4.5] - 2019-04-27
### Changed
* bb_msg: fix wrong args for stack traces in file mode
* bb_msg: make notrace default as said in API docu

## [0.4.4] - 2019-04-24
### Changed
* fixed bb_msg_del_target

## [0.4.3] - 2019-04-24
### Changed
* renamed bb_msg_level_of_int to bb_msg_levelname_of_string
* fixed bb_msg

## [0.4.2] - 2019-04-24
### Changed
* extra check in bb_log if LOG_FILE is empty

## [0.4.1] - 2019-04-23
### Changed
* typo in bb_log

## [0.4] - 2019-04-23
### Add
+ new message tools
+ array tools
+ regress tests
+ error handling (e.g. ierr)
+ autogenerated API docu
### Changed
* enhanced error code schema
* multiple ways to load libraries
* deprecate old log functions
* make all functions use new message tools

## [0.3.9] - 2019-01-14
### Add
+ add bb_finalize

## [0.3.8] - 2019-01-11
### Changed
* bb_register_exit_hook now takes 1 or 2 args
* Makefile cleanup

## [0.3.7] - 2018-11-10
### Changed
* bb_require_libs: error handling uses return values instead of bb_fatal

## [0.3.6] - 2018-11-09
### Changed
* removed another call of deprecated function

## [0.3.5] - 2018-11-08
### Changed
* bb_require_libs now accepts local paths starting with './' and '../'
* stopped using deprecated functions in own code

## [0.3.4] - 2018-11-08
### Changed
* bb_require_libs now accepts local paths starting with './'
* non bb_ funs emit a deprecation warning

## [0.3.3] - 2018-10-17
### Changed
* bb_quit now accepts optional log msg

## [0.3.2] - 2018-10-08
### Added
+ added bb_exec

## [0.3.1] - 2018-09-26
### Added
+ added bb_logf

## [0.3.0] - 2018-04-11
### Added
+ hook function to be run at program exit can be (un)registered

### Changed
* prefixed `log`, `log_debug` and `fatal` with `bb_`
* traps are installed by default

### Removed
- `bb_traps_setup` and `bb_traps_disable` now just emit deprecated warning

## [0.2.5] - 2018-03-15
### Changed
* `bb_require_libs` supports absolute paths and search now is like docu says

## [0.2.4] - 2018-01-16
### Changed
* failures when loading bash-base in examples and docu now go to stderr

## [0.2.3] - 2018-01-16
### Changed
* fixed `bb_require_libs`

## [0.2.2] - 2018-01-16
### Changed
* smarter lib load paths

## [0.2.1] - 2018-01-16
### Added
+ `bb_require_libs`

### Removed
- Subdir in /usr/libexec

## [0.2] - 2018-01-16
### Added
+ First release

<!--  LocalWords:  Changelog
 -->
